import { __assign, __rest, __spreadArray } from "tslib";
import { aggregateToQuery } from "./aggregateToQuery";
import { RTKLoader } from "./RTKLoader";
export var createUseLoader = function (createUseLoaderArgs) {
    var useLoader = function () {
        var _a, _b;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var createdQueries = createUseLoaderArgs.queries.apply(createUseLoaderArgs, args);
        var deferredQueries = (_b = (_a = createUseLoaderArgs.deferredQueries) === null || _a === void 0 ? void 0 : _a.call.apply(_a, __spreadArray([createUseLoaderArgs], args, false))) !== null && _b !== void 0 ? _b : [];
        var aggregatedQuery = aggregateToQuery(createdQueries);
        if (aggregatedQuery.isSuccess ||
            createdQueries.length === 0) {
            var data = createUseLoaderArgs.transform
                ? createUseLoaderArgs.transform(createdQueries, deferredQueries)
                : createdQueries;
            return __assign(__assign({}, aggregatedQuery), { isSuccess: true, data: data, currentData: data, originalArgs: args });
        }
        return aggregatedQuery;
    };
    return useLoader;
};
export var createLoader = function (createLoaderArgs) {
    var _a, _b;
    var useLoader = createUseLoader({
        queries: (_a = createLoaderArgs.queries) !== null && _a !== void 0 ? _a : (function () { return []; }),
        transform: createLoaderArgs.transform,
        deferredQueries: createLoaderArgs.deferredQueries
    });
    var loader = {
        useLoader: useLoader,
        onLoading: createLoaderArgs.onLoading,
        onError: createLoaderArgs.onError,
        onFetching: createLoaderArgs.onFetching,
        whileFetching: createLoaderArgs.whileFetching,
        queriesArg: createLoaderArgs.queriesArg,
        LoaderComponent: (_b = createLoaderArgs.loaderComponent) !== null && _b !== void 0 ? _b : RTKLoader,
        extend: function (_a) {
            var queries = _a.queries, deferredQueries = _a.deferredQueries, transform = _a.transform, loaderArgs = __rest(_a, ["queries", "deferredQueries", "transform"]);
            var extendedLoader = __assign(__assign({}, this), loaderArgs);
            if (queries) {
                var newUseLoader = createUseLoader({
                    queries: queries,
                    transform: transform,
                    deferredQueries: deferredQueries
                });
                extendedLoader.useLoader = newUseLoader;
            }
            return extendedLoader;
        }
    };
    return loader;
};
//# sourceMappingURL=createLoader.js.map